package ru.crazyprojects.android.snake;

import android.graphics.Canvas;
import android.graphics.drawable.Drawable;

public class Buttons {
	private int X, Y;
	private int Width, Height;
	
	private Drawable imgPressed, imgReleased;
	
	private boolean pressedFlag;
	private boolean showFlag;
	
	public Buttons(int btnX, int btnY, int btnWidth, int btnHeight, Drawable btnReleased, Drawable btnPressed) {
		X = btnX;
		Y = btnY;
		Width = btnWidth;
		Height = btnHeight;
		
		imgPressed = btnPressed;
		imgReleased = btnReleased;
		
		imgPressed.setBounds(X, Y, X+Width, Y+Height);
		imgReleased.setBounds(X, Y, X+Width, Y+Height);
		
		pressedFlag = false;
		showFlag = true;
	}
	
	public boolean isPressed() {
		if (showFlag) {
			return pressedFlag;
		}
		return false;
	}
	
	public boolean isInside(int touchX, int touchY) {
		if ((touchX > X)&&(touchX < X+Width)&&(touchY > Y)&&(touchY < Y+Height)&&(showFlag)) {
			return true;
		}
		return false;
	}
	
	public void Pressed(boolean pressed) {
		pressedFlag = pressed;
	}
	
	public void Draw(Canvas canvas) {
		if (showFlag) {
			if (pressedFlag) {
				imgPressed.draw(canvas);
			} else {
				imgReleased.draw(canvas);
			}
		}
	}
	
	public void Show() {
		showFlag = true;
	}
	
	public void Hide() {
		showFlag = false;
	}
}