package ru.crazyprojects.android.snake;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;

public class Carrots {
	private int X;
	private int Y;
	private long startTimer;
	private long lifeTime;
	private boolean alive;
	
	private Drawable CarrotImg;
	
	private int frameWidth;
	private int frameHeight;

// 	
	public Carrots(Context context, int startX, int startY, long life) {
		X = startX;
		Y = startY;
		lifeTime = life;
		startTimer = System.currentTimeMillis();
		alive = true;
		
		CarrotImg = context.getResources().getDrawable(R.drawable.carrot);
		
		frameWidth = CarrotImg.getIntrinsicWidth();
		frameHeight = CarrotImg.getIntrinsicHeight();
	}
	
//   
	public void Draw(Canvas canvas) {
		CarrotImg.setBounds(X, Y, X+frameWidth, Y+frameHeight);
		CarrotImg.draw(canvas);
		if (lifeTime>0) {
			if (System.currentTimeMillis() > startTimer+lifeTime) alive = false;
		}
	}
	
//   X 	
	public int getCarrotX() {
		return X;
	}
	
//   Y 
	public int getCarrotY(){
		return Y;
	}
	
//    	
	public boolean isAlive() {
		return alive;
	}
}
