package ru.crazyprojects.android.snake;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;

public class Cherry {
	private int X;
	private int Y;
	private long startTimer;
	private long lifeTime;
	private boolean alive;
	
	private Drawable CherryImg;
	
	private int frameWidth;
	private int frameHeight;
	
// 	
	public Cherry(Context context, int startX, int startY, long life) {
		X = startX;
		Y = startY;
		lifeTime = life;
		startTimer = System.currentTimeMillis();
		alive = true;
		
		CherryImg = context.getResources().getDrawable(R.drawable.cherry);
		
		frameWidth = CherryImg.getIntrinsicWidth();
		frameHeight = CherryImg.getIntrinsicHeight();
	}
	
//   	
	public void Draw(Canvas canvas) {
		CherryImg.setBounds(X, Y, X+frameWidth, Y+frameHeight);
		CherryImg.draw(canvas);
		if (lifeTime>0) {
			if (System.currentTimeMillis() > startTimer+lifeTime) alive = false;
		}
	}
	
//   X 	
	public int getCherryX() {
		return X;
	}
	
//   Y 	
	public int getCherryY() {
		return Y;
	}
	
//     	
	public boolean isAlive() {
		return alive;
	}
}
