package ru.crazyprojects.android.snake;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;

public class Frogs {
	private int X;
	private int Y;
	private long startTimer;
	private long lifeTime;
	private boolean alive;
	
	private Drawable FrogImg;
	
	private int frameWidth;
	private int frameHeight;
	
// 	
	public Frogs(Context context, int startX, int startY, long life) {
		X = startX;
		Y = startY;
		lifeTime = life;
		startTimer = System.currentTimeMillis();
		alive = true;
		
		FrogImg = context.getResources().getDrawable(R.drawable.kva);
		
		frameWidth = FrogImg.getIntrinsicWidth();
		frameHeight = FrogImg.getIntrinsicHeight();
	}
	
//   	
	public void Draw(Canvas canvas) {
		FrogImg.setBounds(X, Y, X+frameWidth, Y+frameHeight);
		FrogImg.draw(canvas);
		if (lifeTime>0) {
			if (System.currentTimeMillis() > startTimer+lifeTime) alive = false;
		}
	}
	
//   X 	
	public int getFrogX() {
		return X;
	}
	
//   Y 	
	public int getFrogY() {
		return Y;
	}
	
//     	
	public boolean isAlive() {
		return alive;
	}
}
