package ru.crazyprojects.android.snake;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;

public class Mushrooms {
	private int X;
	private int Y;
	private long startTimer;
	private long lifeTime;
	private boolean alive;
	
	private Drawable MushroomImg;
	
	private int frameWidth;
	private int frameHeight;
	
// 	
	public Mushrooms(Context context, int startX, int startY, long life) {
		X = startX;
		Y = startY;
		lifeTime = life;
		startTimer = System.currentTimeMillis();
		alive = true;
		
		MushroomImg = context.getResources().getDrawable(R.drawable.mash);
		
		frameWidth = MushroomImg.getIntrinsicWidth();
		frameHeight = MushroomImg.getIntrinsicHeight();
	}
	
//   	
	public void Draw(Canvas canvas) {
		MushroomImg.setBounds(X, Y, X+frameWidth, Y+frameHeight);
		MushroomImg.draw(canvas);
		if (lifeTime>0) {
			if (System.currentTimeMillis() > startTimer+lifeTime) alive = false;
		}
	}
	
//   X 	
	public int getMushroomX() {
		return X;
	}
	
//   Y 	
	public int getMushroomY() {
		return Y;
	}
	
//     	
	public boolean isAlive() {
		return alive;
	}
}
