package ru.crazyprojects.android.snake;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;

public class Pear {
	private int X;
	private int Y;
	private long startTimer;
	private long lifeTime;
	private boolean alive;
	
	private Drawable PearImg;
	
	private int frameWidth;
	private int frameHeight;
	
// 	
	public Pear(Context context, int startX, int startY, long life) {
		X = startX;
		Y = startY;
		lifeTime = life;
		startTimer = System.currentTimeMillis();
		alive = true;
		
		PearImg = context.getResources().getDrawable(R.drawable.peach);
		
		frameWidth = PearImg.getIntrinsicWidth();
		frameHeight = PearImg.getIntrinsicHeight();
	}
	
//   	
	public void Draw(Canvas canvas) {
		PearImg.setBounds(X, Y, X+frameWidth, Y+frameHeight);
		PearImg.draw(canvas);
		if (lifeTime>0) {
			if (System.currentTimeMillis() > startTimer+lifeTime) alive = false;
		}
	}
	
//   X 	
	public int getPearX() {
		return X;
	}
	
//   Y 	
	public int getPearY() {
		return Y;
	}
	
//     	
	public boolean isAlive() {
		return alive;
	}
}
