package ru.crazyprojects.android.snake;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;

public class Rabbits {
	private int X;
	private int Y;
	private long startTimer;
	private long lifeTime;
	private boolean alive;
	
	private Drawable RabbitImg;
	
	private int frameWidth;
	private int frameHeight;
	
// 	
	public Rabbits(Context context, int startX, int startY, long life) {
		X = startX;
		Y = startY;
		lifeTime = life;
		startTimer = System.currentTimeMillis();
		alive = true;
		
		RabbitImg = context.getResources().getDrawable(R.drawable.rabbit);
		
		frameWidth = RabbitImg.getIntrinsicWidth();
		frameHeight = RabbitImg.getIntrinsicHeight();
	}
	
//   	
	public void Draw(Canvas canvas) {
		RabbitImg.setBounds(X, Y, X+frameWidth, Y+frameHeight);
		RabbitImg.draw(canvas);
		if (lifeTime>0) {
			if (System.currentTimeMillis() > startTimer+lifeTime) alive = false;
		}
	}
	
//   X 	
	public int getRabbitX() {
		return X;
	}
	
//   Y 	
	public int getRabbitY() {
		return Y;
	}
	
//     	
	public boolean isAlive() {
		return alive;
	}

}
