package ru.crazyprojects.android.snake;

import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Window;
import android.view.WindowManager;
import android.app.Activity;
import android.content.pm.ActivityInfo;

public class Snake extends Activity implements SensorEventListener {
//  	
	public static final byte EMPTY = 0;
	public static final byte SNAKE_HEAD = 1;
	public static final byte SNAKE_BODY = 2;
	public static final byte SNAKE_TAIL = 3; 
	public static final byte CARROT = 4;
	public static final byte RABBIT = 5;
	public static final int SPRITE_SIZE = 20;
	public static final byte STATISTIC_LINE = SPRITE_SIZE * 2;
	
	private SnakeView snakeView;
	
	private SensorManager sensorManager;

	private float axisX, axisY, axisZ;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        
        setContentView(R.layout.main);
		
		sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
		sensorManager.registerListener(this, sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER), SensorManager.SENSOR_DELAY_GAME);
		
		snakeView = (SnakeView) findViewById(R.id.game);
	}

	@Override
    public void onPause() {
    	super.onPause();
    	sensorManager.unregisterListener(this);
    	snakeView.terminateThread();
    }
    
    @Override
    public void onResume() {
    	super.onResume();
    	if (snakeView.surfaceCreated == true) {
            snakeView.createThread(snakeView.getHolder());
        }
    	sensorManager.registerListener(this, sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER), SensorManager.SENSOR_DELAY_GAME);
    }

	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onSensorChanged(SensorEvent event) {
		if (event.sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
			axisX = event.values[0]; 
			axisY = event.values[1];
			axisZ = event.values[2];
			snakeView.appThread.snake.SetDirectionBySensor(axisX, axisY, axisZ);
		}
	}
	
	@Override
	protected void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		if (snakeView.appThread.gameMenu == 2) {
			snakeView.appThread.DB.delete("Resume", "", null);
			snakeView.appThread.DB.delete("ResumeSnakeBody", "", null);
		
			snakeView.appThread.DB.execSQL("INSERT INTO Resume (level, lifes, score, length, speed) VALUES ("+Integer.toString(snakeView.appThread.gameLevel)+","+snakeView.appThread.snake.getLifes()+","+snakeView.appThread.scoreCounter+","+snakeView.appThread.snake.getLength()+","+Integer.toString(snakeView.appThread.snakeSpeed)+");");
			int snakeLen = snakeView.appThread.snake.getLength();
			int[][] tmpSnakeArr = snakeView.appThread.snake.getSnakeBody();
			for(int i=0;i<snakeLen;i++) {
				snakeView.appThread.DB.execSQL("INSERT INTO ResumeSnakeBody (level, x, y) VALUES ("+Integer.toString(snakeView.appThread.gameLevel)+","+Integer.toString(tmpSnakeArr[i][0])+","+Integer.toString(tmpSnakeArr[i][1])+");");
			}
		}
		snakeView.appThread.DB.close();
	}
	
	@Override
	protected void onRestoreInstanceState(Bundle inState) {
		super.onRestoreInstanceState(inState);
	}
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
	    if ((keyCode == KeyEvent.KEYCODE_BACK)) {
	        switch (snakeView.appThread.gameMenu) {
	        	case 0:
	        		snakeView.appThread.gameMenu = 1;
	        		break;
	        	case 1:
	        		finish();
	        		break;
	        	case 2:
	        		snakeView.appThread.DB.delete("Resume", "", null);
	    			snakeView.appThread.DB.delete("ResumeSnakeBody", "", null);
	    		
	    			snakeView.appThread.DB.execSQL("INSERT INTO Resume (level, lifes, score, length, speed) VALUES ("+Integer.toString(snakeView.appThread.gameLevel)+","+snakeView.appThread.snake.getLifes()+","+snakeView.appThread.scoreCounter+","+snakeView.appThread.snake.getLength()+","+Integer.toString(snakeView.appThread.snakeSpeed)+");");
	    			int snakeLen = snakeView.appThread.snake.getLength();
	    			int[][] tmpSnakeArr = snakeView.appThread.snake.getSnakeBody();
	    			for(int i=0;i<snakeLen;i++) {
	    				snakeView.appThread.DB.execSQL("INSERT INTO ResumeSnakeBody (level, x, y) VALUES ("+Integer.toString(snakeView.appThread.gameLevel)+","+Integer.toString(tmpSnakeArr[i][0])+","+Integer.toString(tmpSnakeArr[i][1])+");");
	    			}
	        		snakeView.appThread.gameMenu = 1;
	        		break;
	        	case 3:
	        		snakeView.appThread.gameMenu = 1;
	        		break;
	        	case 4:
	        		snakeView.appThread.gameMenu = 1;
	        		break;
	        	case 5:
	        		snakeView.appThread.gameMenu = 1;
	        		break;
	        }
	        return false;
	    }
	    return super.onKeyDown(keyCode, event);
	} 
}
