package ru.crazyprojects.android.snake;

import java.util.Random;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;
import android.view.MotionEvent;
import android.view.SurfaceHolder;

public class SnakeDraw extends Thread {
	
	private SurfaceHolder appScreen;
	private boolean appRunning;								//   
	private boolean appPaused;								//   
	private int screenWidth, screenHeight; 					//  
	private Bitmap clearScreen;								//    
	private Drawable bg;									//   
	private Drawable Splash;								//   
	private Drawable black_bg;								//    
	private Drawable levelUp;								//    
	private Drawable heart;									//  
	private Drawable score;									//  
	private Drawable level;									//   
	private Drawable noSavedLevels;							//   
	private Drawable help;
	public int scoreCounter;								//  
	private Drawable zero, one, two, three, four, five, six, seven, eight, nine; 
	private int levelUpY;									//  Y   LevelUP
	private boolean levelUpFlag;							//     
	private int levelsToSelect;								//    
	public int snakeSpeed;									//  
	
	private SnakeDBHelper DBHelper;
	public SQLiteDatabase DB;
	
	public Snakes snake;									// 
	
	private Rabbits rabbits[];								//  
	private Carrots carrots[];								//  
	private Cherry cherrys[];								//  
	private Limon limons[];									//  
	private Mushrooms mushrooms[];							//  
	private Pear pears[]; 									//  
	private Frogs frogs[];									//  
	private Chickens chickens[];							//  	
	
//	private Stone stones[];									//   
	
	private Random Rnd;										// 
	
	private Context appContext;						
	
	public byte gameLevel;									//   
	//    	
	private static final byte MAX_LEVELS = 15;
	
/*										0		1		2			3			4			5		6		7			8		9			10			11			12		13			14		15			16			17			18
 * 									Start  |	   |Rabbits		|			|Carrots	|Snake	|		|Cherrys	|		|Limons		|			|Mushrooms	|		|Pears		|		|Frogs		|			|Chickens	|		|
 * 									snake  |	   |life		|			|life		|start	|		|life		|		|life		|			|life		|		|life		|		|life		|			|life		|		|
 * 									length |Rabbits|time		|Carrots	|time		|speed	|Cherrys|time		|Limons	|time		|Mushrooms	|time		|Pears	|time		|Frogs	|time		|Chickens	|time		|Stones	|*/
	private int levelParams[][] = {{20, 		1, 		0, 			0, 			0, 			0, 		0,		0,			0,		0,			0,			0,			0,		0,			0,		0,			0,			0,			0,},
									{30, 		1,		20000,		1, 			0, 			10,		0,		0,			0,		0,			0,			0,			0,		0,			0,		0,			0,			0,			0,},
									{40, 		3, 		10000, 		3,	 		10000, 		20,		0,		0,			0,		0,			0,			0,			0,		0,			0,		0,			0,			0,			0,},
									{45, 		3, 		20000, 		5,	 		10000, 		20,		0,		0,			0,		0,			0,			0,			0,		0,			0,		0,			0,			0,			0,},
									{45, 		5,	 	10000, 		5,	 		10000, 		20,		0,		0,			0,		0,			0,			0,			0,		0,			0,		0,			0,			0,			0,},
									{50,		5,		20000,		3,			0,			40,		0,		0,			0,		0,			0,			0,			0,		0,			0,		0,			0,			0,			0,},
									{50,		10,		0,			10,			0,			40,		0,		0,			0,		0,			0,			0,			1,		0,			0,		0,			0,			0,			0,},
									{60,		10,		10000,		10,			10000,		60,		0,		0,			1,		10000,		0,			0,			0,		0,			0,		0,			0,			0,			0,},
									{60,		2,		5000,		3,			5000,		40,		1,		0,			0,		0,			1,			10000,		2,		5000,		0,		0,			0,			0,			0,},
									{50,		10,		3000,		10,			3000,		100,	5,		5000,		1,		0,			2,			5000,		1,		5000,		1,		3000,		0,			0,			0,},
									{60,		20,		2000,		5,			3000,		100,	3,		3000,		1,		5000,		3,			10000,		3,		5000,		1,		2000,		0,			0,			0,},
									{50,		30,		2000,		10,			0,			40,		2,		2000,		2,		5000,		4,			5000,		4,		5000,		2,		3000,		0,			0,			0,},
									{50,		10,		5000,		3,			3000,		100,	1,		0,			1,		0,			5,			5000,		2,		10000,		1,		0,			0,			0,			0,},
									{60,		5,		10000,		2,			0,			40,		3,		5000,		2,		10000,		5,			20000,		3,		2000,		2,		10000,		0,			0,			0,},
									{60,		7,		2000,		7,			2000,		120,	7,		2000,		7,		2000,		7,			2000,		7,		2000,		7,		2000,		1,			2000,		0,}};
	
	private Buttons[] levelButtons;
	
//   	
	private static final byte SNAKE_LENGTH = 0;
	private static final byte RABBITS = 1;
	private static final byte RABBITS_LIFE = 2;
	private static final byte CARROTS = 3;
	private static final byte CARROTS_LIFE = 4;
	private static final byte SNAKE_SPEED = 5;
	private static final byte CHERRYS = 6;
	private static final byte CHERRYS_LIFE = 7;
	private static final byte LIMONS = 8;
	private static final byte LIMONS_LIFE = 9;
	private static final byte MUSHROOMS = 10;
	private static final byte MUSHROOMS_LIFE = 11;
	private static final byte PEARS = 12;
	private static final byte PEARS_LIFE = 13;
	private static final byte FROGS = 14;
	private static final byte FROGS_LIFE = 15;
	private static final byte CHICKENS = 16;
	private static final byte CHICKENS_LIFE = 17;
//	private static final byte STONES = 18;

//  
	private static final int RABBITS_BONUS_CREDITS = 5;
	private static final int RABBITS_BONUS_SPEED = 2;
//	private static final int RABBITS_BONUS_LENGTH = 1;
	
//	private static final int CARROTS_BONUS_CREDITS = 0;
//	private static final int CARROTS_BONUS_SPEED = 0;
//	private static final int CARROTS_BONUS_LENGTH = -1;
	
	private static final int CHERRYS_BONUS_CREDITS = -5;
	private static final int CHERRYS_BONUS_SPEED = 2;
//	private static final int CHERRYS_BONUS_LENGTH = -1;
	
//	private static final int LIMONS_BONUS_CREDITS = 0;
	private static final int LIMONS_BONUS_SPEED = -25;
//	private static final int LIMONS_BONUS_LENGTH = -1;
	
//	private static final int MUSHROOMS_BONUS_CREDITS = 0;
	private static final int MUSHROOMS_BONUS_SPEED = 50;
//	private static final int MUSHROOMS_BONUS_LENGTH = 0;
	
//	private static final int PEARS_BONUS_CREDITS = 0;
	private static final int PEARS_BONUS_SPEED = -5;
//	private static final int PEARS_BONUS_LENGTH = 0;
	
	private static final int FROGS_BONUS_CREDITS = 50;
	private static final int FROGS_BONUS_SPEED = 5;
//	private static final int FROGS_BONUS_LENGTH = 1;
	
	private static final int CHICKENS_BONUS_CREDITS = 25;
	private static final int CHICKENS_BONUS_SPEED = 5;
//	private static final int CHICKENS_BONUS_LENGTH = 1;
	private static final int CHICKENS_BONUS_LIFE = 1;
	
//     	
	private static final int MAX_RABBITS = 50;
	private static final int MAX_CARROTS = 50;
	private static final int MAX_CHERRYS = 50;
	private static final int MAX_LIMONS = 50;
	private static final int MAX_MUSHROOMS = 50;
	private static final int MAX_FROGS = 50;
	private static final int MAX_PEARS = 50;
	private static final int MAX_CHICKENS = 50;
//	private static final int MAX_STONES = 100;
	
	
//   	
	public byte gameMenu;
	
//   	
	private Buttons playButton;
	private Buttons resumeButton;
	private Buttons levelsButton;
	private Buttons helpButton;
	private Buttons backButton;

//   	
	private static final byte MENU_SPLASH = 0;
	private static final byte MENU_MAIN = 1;
	private static final byte MENU_PLAY = 2;
	private static final byte MENU_RESUME = 3;
	private static final byte MENU_LEVELS = 4;
	private static final byte MENU_HELP = 5;
	
//  	
	public SnakeDraw(SurfaceHolder surfaceHolder, Context context, int Width, int Height) {
		//       
		DBHelper = new SnakeDBHelper(context);
		DB = DBHelper.getWritableDatabase();
		
		//  
		Rnd = new Random();
		appContext = context;
		gameLevel = 0;
		gameMenu = MENU_SPLASH;
		appScreen = surfaceHolder;
		appRunning = false;
		appPaused = false;
		screenWidth = Width;
		screenHeight = Height;
		snakeSpeed = levelParams[gameLevel][SNAKE_SPEED];
		levelUpY = 0;
		levelUpFlag = false;
		scoreCounter = 0;
		levelsToSelect = 0;
		UpdateLevels();
		
		//     
		clearScreen = Bitmap.createBitmap(screenWidth, screenHeight, Config.RGB_565);
		Canvas bgCanvas = new Canvas(clearScreen);
		bg = context.getResources().getDrawable(R.drawable.bg);
		Drawable grass = context.getResources().getDrawable(R.drawable.grass);
		bg.setBounds(0, 0, screenWidth, screenHeight);
		bg.draw(bgCanvas);
		for(int i=0; i<20; i++) {
			int tmpX = Rnd.nextInt(screenWidth/Snake.SPRITE_SIZE-1)*Snake.SPRITE_SIZE;
			int tmpY = Rnd.nextInt((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1)*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
			grass.setBounds(tmpX, tmpY, tmpX+grass.getIntrinsicWidth(), tmpY+grass.getIntrinsicHeight());
			grass.draw(bgCanvas);
		}
		black_bg = context.getResources().getDrawable(R.drawable.black);
		black_bg.setBounds(0, 0, screenWidth, Snake.STATISTIC_LINE);
		black_bg.draw(bgCanvas);
		
		// Level UP
		levelUp = context.getResources().getDrawable(R.drawable.level_up);
		//  
		heart = context.getResources().getDrawable(R.drawable.heart);
		heart.setBounds(Snake.STATISTIC_LINE*3, 0, Snake.STATISTIC_LINE*4, Snake.SPRITE_SIZE*2);
		//  
		score = context.getResources().getDrawable(R.drawable.score);
		float tmpScoreWidth = Snake.STATISTIC_LINE*score.getIntrinsicWidth()/score.getIntrinsicHeight();
		score.setBounds(Snake.STATISTIC_LINE*6, 0, Math.round(Snake.STATISTIC_LINE*6+tmpScoreWidth), Snake.STATISTIC_LINE);
		//  
		level = context.getResources().getDrawable(R.drawable.level);
		level.setBounds(0, 0, Math.round(tmpScoreWidth), Snake.STATISTIC_LINE);
		//   
		noSavedLevels = context.getResources().getDrawable(R.drawable.no_saved_levels);
		int noSavedHeight = (screenWidth-screenWidth/5)*noSavedLevels.getIntrinsicHeight()/noSavedLevels.getIntrinsicWidth();
		noSavedLevels.setBounds(screenWidth/10, screenHeight/2-noSavedHeight/2, screenWidth-screenWidth/10, screenHeight/2+noSavedHeight/2);
		//    help
		help = context.getResources().getDrawable(R.drawable.help);
		float helpHeight = screenWidth*help.getIntrinsicHeight()/help.getIntrinsicWidth();
		help.setBounds(0, 0, screenWidth, Math.round(helpHeight));
		// 
		zero = context.getResources().getDrawable(R.drawable.zero); 
		one = context.getResources().getDrawable(R.drawable.one);
		two = context.getResources().getDrawable(R.drawable.two);
		three = context.getResources().getDrawable(R.drawable.three);
		four = context.getResources().getDrawable(R.drawable.four);
		five = context.getResources().getDrawable(R.drawable.five);
		six = context.getResources().getDrawable(R.drawable.six);
		seven = context.getResources().getDrawable(R.drawable.seven);
		eight = context.getResources().getDrawable(R.drawable.eight);
		nine = context.getResources().getDrawable(R.drawable.nine);
		
		//  
		float tmpBtnX = screenWidth/10;
		float tmpBtnWidth = screenWidth-tmpBtnX*2;
		float tmpBtnHeight = tmpBtnWidth/context.getResources().getDrawable(R.drawable.play_button_up).getIntrinsicWidth()*context.getResources().getDrawable(R.drawable.play_button_up).getIntrinsicHeight();
		float tmpBtnY = screenHeight/2;
		float tmpBtnBtw = tmpBtnHeight/3;
		playButton = new Buttons(Math.round(tmpBtnX), Math.round(tmpBtnY-tmpBtnHeight*2-tmpBtnBtw-tmpBtnBtw/2), Math.round(tmpBtnWidth), Math.round(tmpBtnHeight), context.getResources().getDrawable(R.drawable.play_button_up), context.getResources().getDrawable(R.drawable.play_button_down));
		resumeButton = new Buttons(Math.round(tmpBtnX), Math.round(tmpBtnY-tmpBtnHeight-tmpBtnBtw/2), Math.round(tmpBtnWidth), Math.round(tmpBtnHeight), context.getResources().getDrawable(R.drawable.resume_button_up), context.getResources().getDrawable(R.drawable.resume_button_down));
		levelsButton = new Buttons(Math.round(tmpBtnX), Math.round(tmpBtnY+tmpBtnBtw/2), Math.round(tmpBtnWidth), Math.round(tmpBtnHeight), context.getResources().getDrawable(R.drawable.levels_button_up), context.getResources().getDrawable(R.drawable.levels_button_down));
		helpButton = new Buttons(Math.round(tmpBtnX), Math.round(tmpBtnY+tmpBtnHeight+tmpBtnBtw+tmpBtnBtw/2), Math.round(tmpBtnWidth), Math.round(tmpBtnHeight), context.getResources().getDrawable(R.drawable.help_button_up), context.getResources().getDrawable(R.drawable.help_button_down));
		backButton = new Buttons(Math.round(tmpBtnX), Math.round(screenHeight-tmpBtnHeight-tmpBtnBtw), Math.round(tmpBtnWidth), Math.round(tmpBtnHeight), context.getResources().getDrawable(R.drawable.back_button_up), context.getResources().getDrawable(R.drawable.back_button_down));
		
		//  
		float levelBtnSize = screenWidth/4-screenWidth/20; 
		levelButtons = new Buttons[MAX_LEVELS];
		levelButtons[0] = new Buttons(Math.round(screenWidth/4-levelBtnSize/2), Math.round(levelBtnSize/2), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l1_up), context.getResources().getDrawable(R.drawable.l1_down));
		levelButtons[1] = new Buttons(Math.round(screenWidth/4*2-levelBtnSize/2), Math.round(levelBtnSize/2), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l2_up), context.getResources().getDrawable(R.drawable.l2_down));
		levelButtons[2] = new Buttons(Math.round(screenWidth/4*3-levelBtnSize/2), Math.round(levelBtnSize/2), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l3_up), context.getResources().getDrawable(R.drawable.l3_down));
		
		levelButtons[3] = new Buttons(Math.round(screenWidth/4-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize+levelBtnSize/5), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l4_up), context.getResources().getDrawable(R.drawable.l4_down));
		levelButtons[4] = new Buttons(Math.round(screenWidth/4*2-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize+levelBtnSize/5), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l5_up), context.getResources().getDrawable(R.drawable.l5_down));
		levelButtons[5] = new Buttons(Math.round(screenWidth/4*3-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize+levelBtnSize/5), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l6_up), context.getResources().getDrawable(R.drawable.l6_down));
		
		levelButtons[6] = new Buttons(Math.round(screenWidth/4-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize*2+levelBtnSize/5*2), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l7_up), context.getResources().getDrawable(R.drawable.l7_down));
		levelButtons[7] = new Buttons(Math.round(screenWidth/4*2-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize*2+levelBtnSize/5*2), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l8_up), context.getResources().getDrawable(R.drawable.l8_down));
		levelButtons[8] = new Buttons(Math.round(screenWidth/4*3-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize*2+levelBtnSize/5*2), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l9_up), context.getResources().getDrawable(R.drawable.l9_down));
		
		levelButtons[9] = new Buttons(Math.round(screenWidth/4-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize*3+levelBtnSize/5*3), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l10_up), context.getResources().getDrawable(R.drawable.l10_down));
		levelButtons[10] = new Buttons(Math.round(screenWidth/4*2-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize*3+levelBtnSize/5*3), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l11_up), context.getResources().getDrawable(R.drawable.l11_down));
		levelButtons[11] = new Buttons(Math.round(screenWidth/4*3-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize*3+levelBtnSize/5*3), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l12_up), context.getResources().getDrawable(R.drawable.l12_down));
		
		levelButtons[12] = new Buttons(Math.round(screenWidth/4-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize*4+levelBtnSize/5*4), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l13_up), context.getResources().getDrawable(R.drawable.l13_down));
		levelButtons[13] = new Buttons(Math.round(screenWidth/4*2-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize*4+levelBtnSize/5*4), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l14_up), context.getResources().getDrawable(R.drawable.l14_down));
		levelButtons[14] = new Buttons(Math.round(screenWidth/4*3-levelBtnSize/2), Math.round(levelBtnSize/2+levelBtnSize*4+levelBtnSize/5*4), Math.round(levelBtnSize), Math.round(levelBtnSize), context.getResources().getDrawable(R.drawable.l15_up), context.getResources().getDrawable(R.drawable.l15_down));
		for(int i=0;i<MAX_LEVELS;i++) {
			levelButtons[i].Hide();
		}
		
		
		Splash = context.getResources().getDrawable(R.drawable.snake_splash);
		
		snake = new Snakes(context, 0, 0, Snake.SPRITE_SIZE, screenWidth, screenHeight);
		
		//  
		rabbits = new Rabbits[MAX_RABBITS];
		for(int i=0;i<MAX_RABBITS;i++) {
			int tmpX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
			int tmpY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
			rabbits[i] = new Rabbits(context, tmpX, tmpY, levelParams[gameLevel][RABBITS_LIFE]);
		}
		
		//  
		carrots = new Carrots[MAX_CARROTS];
		for(int i=0;i<MAX_CARROTS;i++) {
			int tmpX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
			int tmpY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
			carrots[i] = new Carrots(context, tmpX, tmpY, levelParams[gameLevel][CARROTS_LIFE]);
		}
		
		//  
		cherrys = new Cherry[MAX_CHERRYS];
		for(int i=0;i<MAX_CHERRYS;i++) {
			int tmpX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
			int tmpY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
			cherrys[i] = new Cherry(context, tmpX, tmpY, levelParams[gameLevel][CHERRYS_LIFE]);
		}
		
		//  
		limons = new Limon[MAX_LIMONS];
		for(int i=0;i<MAX_LIMONS;i++) {
			int tmpX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
			int tmpY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
			limons[i] = new Limon(context, tmpX, tmpY, levelParams[gameLevel][LIMONS_LIFE]);
		}
		
		//  
		mushrooms = new Mushrooms[MAX_MUSHROOMS];
		for(int i=0;i<MAX_MUSHROOMS;i++) {
			int tmpX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
			int tmpY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
			mushrooms[i] = new Mushrooms(context, tmpX, tmpY, levelParams[gameLevel][MUSHROOMS_LIFE]);
		}
		
		//  
		pears = new Pear[MAX_PEARS];
		for(int i=0;i<MAX_PEARS;i++) {
			int tmpX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
			int tmpY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
			pears[i] = new Pear(context, tmpX, tmpY, levelParams[gameLevel][PEARS_LIFE]);
		}
		
		//  
		frogs = new Frogs[MAX_FROGS];
		for(int i=0;i<MAX_PEARS;i++) {
			int tmpX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
			int tmpY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
			frogs[i] = new Frogs(context, tmpX, tmpY, levelParams[gameLevel][FROGS_LIFE]);
		}
		
		//  
		chickens = new Chickens[MAX_CHICKENS];
		for(int i=0;i<MAX_CHICKENS;i++) {
			int tmpX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
			int tmpY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
			chickens[i] = new Chickens(context, tmpX, tmpY, levelParams[gameLevel][CHICKENS_LIFE]);
		}
		
		SaveLevel();
	}
		
//    
	public boolean Touch(MotionEvent event) {
		int mouseX = (int)event.getX();
		int mouseY = (int)event.getY();
		switch (gameMenu) {
			case MENU_SPLASH:
				switch(event.getAction()) {
					case MotionEvent.ACTION_UP:
						gameMenu = MENU_MAIN;
						mouseX = 0;
						mouseY = 0;
						break;
				}
				break;
			case MENU_MAIN:
				switch(event.getAction()) {
					case MotionEvent.ACTION_DOWN:
						if (playButton.isInside(mouseX, mouseY)) playButton.Pressed(true);
						if (resumeButton.isInside(mouseX, mouseY)) resumeButton.Pressed(true);
						if (levelsButton.isInside(mouseX, mouseY)) levelsButton.Pressed(true);
						if (helpButton.isInside(mouseX, mouseY)) helpButton.Pressed(true);
						break;
					case MotionEvent.ACTION_UP:
						if (playButton.isInside(mouseX, mouseY)) gameMenu = MENU_PLAY;
						if (resumeButton.isInside(mouseX, mouseY)) gameMenu= MENU_RESUME;
						if (levelsButton.isInside(mouseX, mouseY)) gameMenu = MENU_LEVELS;
						if (helpButton.isInside(mouseX, mouseY)) gameMenu = MENU_HELP;
						playButton.Pressed(false);
						resumeButton.Pressed(false);
						levelsButton.Pressed(false);
						helpButton.Pressed(false);
						break;
				}
				mouseX = 0;
				mouseY = 0;
				break;
			case MENU_PLAY:
				break;
			case MENU_RESUME:
				break;
			case MENU_LEVELS:
				switch(event.getAction()) {
					case MotionEvent.ACTION_DOWN:
						if (backButton.isInside(mouseX, mouseY)) backButton.Pressed(true);
						for(int i=0;i<MAX_LEVELS-1;i++) {
							if (levelButtons[i].isInside(mouseX, mouseY)) levelButtons[i].Pressed(true);
						}
						break;
					case MotionEvent.ACTION_UP:
						if (backButton.isInside(mouseX, mouseY)) gameMenu = MENU_MAIN;
						backButton.Pressed(false);
						for(int i=0;i<MAX_LEVELS-1;i++) {
							if (levelButtons[i].isInside(mouseX, mouseY)) {
								gameLevel = (byte) i;
								LoadLevel((byte) (gameLevel));
								levelButtons[i].Pressed(false);
								gameMenu = MENU_PLAY;
							}
						}
						break;
				}
				mouseX = 0;
				mouseY = 0;
				break;
			case MENU_HELP:
				switch(event.getAction()) {
					case MotionEvent.ACTION_DOWN:
						if (backButton.isInside(mouseX, mouseY)) backButton.Pressed(true);
						break;
					case MotionEvent.ACTION_UP:
						if (backButton.isInside(mouseX, mouseY)) gameMenu = MENU_MAIN;
						backButton.Pressed(false);
						break;
				}
				mouseX = 0;
				mouseY = 0;
				break;
		}
		return true;
	}
		
//    	
	public void setRunning(boolean status) {
		appRunning = status;
	}	
		
//  	
	@Override
	public void run() {
		while(appRunning) {
			if (!appPaused) {
				Canvas canvas = null;
				try {
					canvas = appScreen.lockCanvas();
					synchronized(appScreen) {
						switch (gameMenu) {
							case MENU_SPLASH:
								Splash(canvas);
								break;
							case MENU_MAIN:
								Menu(canvas);
								break;
							case MENU_PLAY:
								Game(canvas);
								break;
							case MENU_RESUME:
								Resume();
								gameMenu = MENU_PLAY;
								break;
							case MENU_LEVELS:
								ShowLevels(canvas);
								break;
							case MENU_HELP:
								Help(canvas);
								break;
						}
						if (gameMenu == MENU_PLAY) {
							sleep(200-snakeSpeed);
						}
					}
				} catch (Exception e) { }
				finally {
					if (canvas != null) { appScreen.unlockCanvasAndPost(canvas); }
				}
			}
		}
	}
	
//  	
	private void Game(Canvas canvas) {
		canvas.drawBitmap(clearScreen, 0, 0, null);
		//     
		for(int i=0;i<levelParams[gameLevel][RABBITS];i++) {
			if (snake.checkRabbits(rabbits[i])) {
				snake.Increase();
				rabbits[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				rabbits[i] = new Rabbits(appContext, rabTempX, rabTempY, levelParams[gameLevel][RABBITS_LIFE]);
				if ((snakeSpeed+RABBITS_BONUS_SPEED<190)&&(snakeSpeed+RABBITS_BONUS_SPEED>=0)) snakeSpeed = snakeSpeed + RABBITS_BONUS_SPEED;
				scoreCounter = scoreCounter + RABBITS_BONUS_CREDITS;
			}
			if (rabbits[i].isAlive() == false) {
				rabbits[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				rabbits[i] = new Rabbits(appContext, rabTempX, rabTempY, levelParams[gameLevel][RABBITS_LIFE]);
			}
		}
		
		//     
		for(int i=0;i<levelParams[gameLevel][CARROTS];i++) {
			if (snake.checkCarrots(carrots[i])) {
				snake.Decrise();
				carrots[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				carrots[i] = new Carrots(appContext, rabTempX, rabTempY, levelParams[gameLevel][CARROTS_LIFE]);
			}
			if (carrots[i].isAlive() == false) {
				carrots[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				carrots[i] = new Carrots(appContext, rabTempX, rabTempY, levelParams[gameLevel][CARROTS_LIFE]);
			}
		}
		
		//     
		for(int i=0;i<levelParams[gameLevel][CHERRYS]; i++) {
			if (snake.checkCherrys(cherrys[i])) {
				snake.Decrise();
				cherrys[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				cherrys[i] = new Cherry(appContext, rabTempX, rabTempY, levelParams[gameLevel][CHERRYS_LIFE]);
				if ((snakeSpeed+CHERRYS_BONUS_SPEED<190)&&(snakeSpeed+CHERRYS_BONUS_SPEED>=0)) snakeSpeed = snakeSpeed + CHERRYS_BONUS_SPEED;
				scoreCounter = scoreCounter + CHERRYS_BONUS_CREDITS;
			}
			if (cherrys[i].isAlive() == false) {
				cherrys[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				cherrys[i] = new Cherry(appContext, rabTempX, rabTempY, levelParams[gameLevel][CHERRYS_LIFE]);
			}
		}
		
		//     
		for(int i=0;i<levelParams[gameLevel][LIMONS]; i++) {
			if (snake.checkLimons(limons[i])) {
				snake.Decrise();
				limons[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				limons[i] = new Limon(appContext, rabTempX, rabTempY, levelParams[gameLevel][LIMONS_LIFE]);
				if ((snakeSpeed+LIMONS_BONUS_SPEED<190)&&(snakeSpeed+LIMONS_BONUS_SPEED>=0)) snakeSpeed = snakeSpeed + LIMONS_BONUS_SPEED;
			}
			if (limons[i].isAlive() == false) {
				limons[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				limons[i] = new Limon(appContext, rabTempX, rabTempY, levelParams[gameLevel][LIMONS_LIFE]); 
			}
		}
		
		//     
		for(int i=0;i<levelParams[gameLevel][MUSHROOMS]; i++) {
			if (snake.checkMushrooms(mushrooms[i])) {
				mushrooms[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				mushrooms[i] = new Mushrooms(appContext, rabTempX, rabTempY, levelParams[gameLevel][MUSHROOMS_LIFE]);
				if ((snakeSpeed+MUSHROOMS_BONUS_SPEED<190)&&(snakeSpeed+MUSHROOMS_BONUS_SPEED>=0)) snakeSpeed = snakeSpeed + MUSHROOMS_BONUS_SPEED;
			}
			if (mushrooms[i].isAlive() == false) {
				mushrooms[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				mushrooms[i] = new Mushrooms(appContext, rabTempX, rabTempY, levelParams[gameLevel][MUSHROOMS_LIFE]);
			}
		}
		
		//     
		for(int i=0;i<levelParams[gameLevel][PEARS]; i++) {
			if (snake.checkPears(pears[i])) {
				pears[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				pears[i] = new Pear(appContext, rabTempX, rabTempY, levelParams[gameLevel][PEARS_LIFE]);
				if ((snakeSpeed+PEARS_BONUS_SPEED<190)&&(snakeSpeed+PEARS_BONUS_SPEED>=0)) snakeSpeed = snakeSpeed + PEARS_BONUS_SPEED;
			}
			if (pears[i].isAlive() == false) {
				pears[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				pears[i] = new Pear(appContext, rabTempX, rabTempY, levelParams[gameLevel][PEARS_LIFE]);
			}
		}
		
		//     
		for(int i=0;i<levelParams[gameLevel][FROGS]; i++) {
			if (snake.checkFrogs(frogs[i])) {
				snake.Increase();
				frogs[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				frogs[i] = new Frogs(appContext, rabTempX, rabTempY, levelParams[gameLevel][FROGS_LIFE]);
				scoreCounter = scoreCounter + FROGS_BONUS_CREDITS;
				if ((snakeSpeed+FROGS_BONUS_SPEED<190)&&(snakeSpeed+FROGS_BONUS_SPEED>=0)) snakeSpeed = snakeSpeed + FROGS_BONUS_SPEED;
			}
			if (frogs[i].isAlive() == false) {
				frogs[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				frogs[i] = new Frogs(appContext, rabTempX, rabTempY, levelParams[gameLevel][FROGS_LIFE]);
			}
		}
		
		//     
		for(int i=0;i<levelParams[gameLevel][CHICKENS]; i++) {
			if (snake.checkChickens(chickens[i])) {
				snake.Increase();
				chickens[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				chickens[i] = new Chickens(appContext, rabTempX, rabTempY, levelParams[gameLevel][CHICKENS_LIFE]);
				if ((snakeSpeed+CHICKENS_BONUS_SPEED<190)&&(snakeSpeed+CHICKENS_BONUS_SPEED>=0)) snakeSpeed = snakeSpeed + CHICKENS_BONUS_SPEED;
				scoreCounter = scoreCounter + CHICKENS_BONUS_CREDITS;
				snake.lifesUp(CHICKENS_BONUS_LIFE);
			}
			if (chickens[i].isAlive() == false) {
				chickens[i] = null;
				int rabTempX = Rnd.nextInt(Math.round(screenWidth/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE;
				int rabTempY = Rnd.nextInt(Math.round((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE-1))*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
				chickens[i] = new Chickens(appContext, rabTempX, rabTempY, levelParams[gameLevel][CHICKENS_LIFE]);
			}
		}
		
		//  
		for(int i=0;i<levelParams[gameLevel][RABBITS];i++) rabbits[i].Draw(canvas);
		for(int i=0;i<levelParams[gameLevel][CARROTS];i++) carrots[i].Draw(canvas);
		for(int i=0;i<levelParams[gameLevel][CHERRYS];i++) cherrys[i].Draw(canvas);
		for(int i=0;i<levelParams[gameLevel][LIMONS];i++) limons[i].Draw(canvas);
		for(int i=0;i<levelParams[gameLevel][MUSHROOMS];i++) mushrooms[i].Draw(canvas);
		for(int i=0;i<levelParams[gameLevel][PEARS];i++) pears[i].Draw(canvas);
		for(int i=0;i<levelParams[gameLevel][FROGS];i++) frogs[i].Draw(canvas);
		for(int i=0;i<levelParams[gameLevel][CHICKENS];i++) chickens[i].Draw(canvas);
		snake.Draw(canvas);
		
		//    
		if (levelParams[gameLevel][SNAKE_LENGTH] == snake.getLength()) {
			snake.resetLength();
			if (gameLevel<MAX_LEVELS) {
				gameLevel++;
				levelUpFlag = true;
				snakeSpeed = levelParams[gameLevel][SNAKE_SPEED];
				UpdateLevels();
			}
			SaveLevel();
		}
		
		DrawStatusLine(canvas);
		LevelUp(canvas);
	}
	
//  	
	private void Menu(Canvas canvas) {
		bg.setBounds(0, 0, screenWidth, screenHeight);
		bg.draw(canvas);
		playButton.Draw(canvas);
		resumeButton.Draw(canvas);
		levelsButton.Draw(canvas);
		helpButton.Draw(canvas);
	}

//  	
	private void Splash(Canvas canvas) {
		Splash.setBounds(0, 0, screenWidth, screenHeight);
		Splash.draw(canvas);
	}

// Level Up 
	private void LevelUp(Canvas canvas) {
		if (levelUpFlag) {
			float tmpLeftX = screenWidth/10;
			float tmpRightX = screenWidth-tmpLeftX;
			float tmpHeight = (tmpRightX-tmpLeftX)/levelUp.getIntrinsicWidth()*levelUp.getIntrinsicHeight();
			levelUp.setBounds(Math.round(tmpLeftX), Math.round(screenHeight-tmpHeight-levelUpY), Math.round(tmpRightX), screenHeight-levelUpY);
			levelUpY = levelUpY + 10;
			if (screenHeight-tmpHeight-levelUpY <= Snake.STATISTIC_LINE) {
				levelUpY = 0;
				levelUpFlag = false;
			}
			levelUp.draw(canvas);
		}
	}
	
// Status Bar
	private void DrawStatusLine(Canvas canvas) {
		level.draw(canvas);
		heart.draw(canvas);
		score.draw(canvas);
		float tmpWidth = Snake.STATISTIC_LINE*zero.getIntrinsicWidth()/zero.getIntrinsicHeight();
		//   
		String tmpLevel = String.valueOf(gameLevel+1);
		int levelLen = tmpLevel.length();
		int startX = Math.round(tmpWidth);
		for(int i=0; i<levelLen; i++) {
			switch (Character.digit(tmpLevel.charAt(i), 10)) {
			case 0:
				zero.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				zero.draw(canvas);
				break;
			case 1:
				one.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				one.draw(canvas);
				break;
			case 2:
				two.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				two.draw(canvas);
				break;
			case 3:
				three.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				three.draw(canvas);
				break;
			case 4:
				four.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				four.draw(canvas);
				break;
			case 5:
				five.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				five.draw(canvas);
				break;
			case 6:
				six.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				six.draw(canvas);
				break;
			case 7:
				seven.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				seven.draw(canvas);
				break;
			case 8:
				eight.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				eight.draw(canvas);
				break;
			case 9:
				nine.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
				nine.draw(canvas);
				break;
			}
		}
		//   
		switch (snake.getLifes()) {
			case 0:
				zero.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				zero.draw(canvas);
				break;
			case 1:
				one.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				one.draw(canvas);
				break;
			case 2:
				two.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				two.draw(canvas);
				break;
			case 3:
				three.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				three.draw(canvas);
				break;
			case 4:
				four.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				four.draw(canvas);
				break;
			case 5:
				five.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				five.draw(canvas);
				break;
			case 6:
				six.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				six.draw(canvas);
				break;
			case 7:
				seven.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				seven.draw(canvas);
				break;
			case 8:
				eight.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				eight.draw(canvas);
				break;
			case 9:
				nine.setBounds(Snake.STATISTIC_LINE*4, 0, Math.round(Snake.STATISTIC_LINE*4+tmpWidth), Snake.STATISTIC_LINE);
				nine.draw(canvas);
				break;
		}
		//  
		String tmpScore = String.valueOf(scoreCounter);
		int scoreLen = tmpScore.length();
		startX = Math.round(Snake.STATISTIC_LINE*6+tmpWidth);
		for(int i=0; i<scoreLen; i++) {
			switch (Character.digit(tmpScore.charAt(i), 10)) {
				case 0:
					zero.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					zero.draw(canvas);
					break;
				case 1:
					one.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					one.draw(canvas);
					break;
				case 2:
					two.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					two.draw(canvas);
					break;
				case 3:
					three.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					three.draw(canvas);
					break;
				case 4:
					four.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					four.draw(canvas);
					break;
				case 5:
					five.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					five.draw(canvas);
					break;
				case 6:
					six.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					six.draw(canvas);
					break;
				case 7:
					seven.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					seven.draw(canvas);
					break;
				case 8:
					eight.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					eight.draw(canvas);
					break;
				case 9:
					nine.setBounds(Math.round(startX+tmpWidth*i), 0, Math.round(Math.round(startX+tmpWidth*(i+1))), Snake.STATISTIC_LINE);
					nine.draw(canvas);
					break;
			}
		}
	}
	
//      	
	public void UpdateLevels() {
		Cursor cursor = DB.rawQuery("SELECT DISTINCT* FROM Saves", null);
		levelsToSelect = cursor.getCount();
	}
	
//      	
	public void ShowLevels(Canvas canvas) {
		bg.setBounds(0, 0, screenWidth, screenHeight);
		bg.draw(canvas);
		
		if (levelsToSelect>0) {
			for(int i=0; i<levelsToSelect;i++) {
				levelButtons[i].Show();
				levelButtons[i].Draw(canvas);
			}
		} else {
			noSavedLevels.draw(canvas);
		}
		backButton.Draw(canvas);
	}
	
//  
	public void LoadLevel(byte level) {
		Cursor cursor = DB.rawQuery("SELECT * FROM Saves WHERE level="+Integer.toString(level)+";", null);
		cursor.moveToLast();
		gameLevel = level;
		scoreCounter = cursor.getInt(3);
		
		int tmpSnakeLen = cursor.getInt(4);
		snake.setLength(tmpSnakeLen);
		snake.setLifes(cursor.getInt(2));
		snakeSpeed = cursor.getInt(5);
	
		cursor = DB.rawQuery("SELECT * FROM SavesSnakeBody WHERE level="+Integer.toString(level)+" ORDER BY id;", null);
		cursor.moveToFirst();
		int[][] tmpSnakeArr = new int[100][2];
		for(int i=0;i<100;i++) {
			tmpSnakeArr[i][0] = 0;
			tmpSnakeArr[i][1] = 0;
		}
		for(int i=0;i<tmpSnakeLen;i++) {
			tmpSnakeArr[i][0]=cursor.getInt(2);
			tmpSnakeArr[i][1]=cursor.getInt(3);
			cursor.moveToNext();
		}
		snake.setSnakeBody(tmpSnakeArr);
	}
	
//   Help	
	public void Help(Canvas canvas) {
		bg.setBounds(0, 0, screenWidth, screenHeight);
		bg.draw(canvas);
		help.draw(canvas);
		backButton.Draw(canvas);
	}
	
//   	
	public void Resume() {
		Cursor cursor = DB.rawQuery("SELECT * FROM Resume", null);
		int numrows = cursor.getCount();
		int snakeLength;
		if (numrows>0) {
			cursor.moveToFirst();
			gameLevel = (byte) cursor.getInt(1);
			snake.setLifes(cursor.getInt(2));
			scoreCounter = cursor.getInt(3);
			snakeLength = cursor.getInt(4);
			snakeSpeed = cursor.getInt(5);
			snake.setLength(snakeLength);
			
			cursor = DB.rawQuery("SELECT * FROM ResumeSnakeBody ORDER BY id ASC", null);
			numrows = cursor.getCount();
			cursor.moveToFirst();
			int[][] tmpResumeSnakeArr = new int[100][2];
			for(int i=0;i<snakeLength;i++) {
				tmpResumeSnakeArr[i][0] = cursor.getInt(2);
				tmpResumeSnakeArr[i][1] = cursor.getInt(3);
				cursor.moveToNext();
			}
			snake.setSnakeBody(tmpResumeSnakeArr);
		}
	}
	
//        
	public void SaveLevel() {
		//   
		DB.delete("Saves", "level="+Integer.toString(gameLevel), null);
		DB.delete("SavesSnakeBody", "level="+Integer.toString(gameLevel), null);
		
		//   
		DB.execSQL("INSERT INTO Saves (level, lifes, score, length, speed) VALUES ("+Integer.toString(gameLevel)+", "+Integer.toString(snake.getLifes())+", "+Integer.toString(scoreCounter)+", "+Integer.toString(snake.getLength())+","+Integer.toString(snakeSpeed)+");");
		int snakeLength = snake.getLength();
		int[][] tmpSaveSnakeArr = snake.getSnakeBody();
		for(int i=0; i<snakeLength; i++) {
			DB.execSQL("INSERT INTO SavesSnakeBody (level, x, y) VALUES ("+Integer.toString(gameLevel)+","+Integer.toString(tmpSaveSnakeArr[i][0])+","+Integer.toString(tmpSaveSnakeArr[i][1])+");");
		} 
	}
}
