package ru.crazyprojects.android.snake;

import android.content.Context;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class SnakeView extends SurfaceView implements SurfaceHolder.Callback{
	private SurfaceHolder appScreen; 
	public SnakeDraw appThread;
	
	public boolean surfaceCreated;
	
	private int screenWidth;
	private int screenHeight;

	public SnakeView(Context context, AttributeSet attrs) {
		super(context, attrs);
		surfaceCreated = false;
		appScreen = getHolder();
		appScreen.addCallback(this);
		
		screenWidth = getResources().getDisplayMetrics().widthPixels;
		screenHeight = getResources().getDisplayMetrics().heightPixels;
		
		appThread = new SnakeDraw(appScreen, context, screenWidth, screenHeight);
		setFocusable(true);		
	}

	@Override
	public void surfaceChanged(SurfaceHolder arg0, int arg1, int arg2, int arg3) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		if (surfaceCreated == false) {
			createThread(holder);
			surfaceCreated = true;
		}
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		terminateThread();
	}
	
//  
	public void terminateThread() {
		boolean retry = true;
		appThread.setRunning(false);
		while(retry) {
			try {
				appThread.join();
				retry = false;
			} catch (InterruptedException e){ }
		}	
	}
			
//  
	public void createThread(SurfaceHolder holder) {
		appThread = new SnakeDraw(holder, getContext(), screenWidth, screenHeight);
		appThread.setRunning(true);
		appThread.start();
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		return appThread.Touch(event);
	}	
}
 