package ru.crazyprojects.android.snake;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;

public class Snakes {
	
	private Drawable HeadImg[];
	private Drawable BodyImg;
	private Drawable TailImg[];
	
	private int screenWidth;
	private int screenHeight;
	private int frameWidth;
	private int frameHeight;
	
	private int Mesh;
	
	private int SnakeBody[][];
	
	private int Direction;
	private int Speed;
	private int SnakeLength;
	
	private int Lifes;
	
	private boolean crash;
	
// 	
	public Snakes(Context context, int StartX, int StartY, int meshStep, int scrWidth, int scrHeight) {
		Direction = 0;
		Mesh = meshStep;
		Speed = Mesh;
		crash = false;
		Lifes = 3;
		
		screenWidth = scrWidth;
		screenHeight = scrHeight;
		
		HeadImg = new Drawable[4];
		TailImg = new Drawable[4];
		HeadImg[0] = context.getResources().getDrawable(R.drawable.snake_head_right);
		HeadImg[1] = context.getResources().getDrawable(R.drawable.snake_head_left);
		HeadImg[2] = context.getResources().getDrawable(R.drawable.snake_head_up);
		HeadImg[3] = context.getResources().getDrawable(R.drawable.snake_head_down);
		BodyImg = context.getResources().getDrawable(R.drawable.snake_body);
		TailImg[0] = context.getResources().getDrawable(R.drawable.snake_tail_right);
		TailImg[1] = context.getResources().getDrawable(R.drawable.snake_tail_left);
		TailImg[2] = context.getResources().getDrawable(R.drawable.snake_tail_up);
		TailImg[3] = context.getResources().getDrawable(R.drawable.snake_tail_down);
		
		frameWidth = BodyImg.getIntrinsicWidth();
		frameHeight = BodyImg.getIntrinsicHeight();
		
		SnakeBody = new int[100][2];
		
		SnakeLength = 5;
		
		int tmpSnakeX = Math.round((screenWidth/Snake.SPRITE_SIZE)/2)*Snake.SPRITE_SIZE;
		int tmpSnakeY = Math.round(((screenHeight-Snake.STATISTIC_LINE)/Snake.SPRITE_SIZE)/2)*Snake.SPRITE_SIZE+Snake.STATISTIC_LINE;
		SnakeBody[0][0] = tmpSnakeX;
		SnakeBody[0][1] = tmpSnakeY-Snake.SPRITE_SIZE*2;
		SnakeBody[1][0] = tmpSnakeX;
		SnakeBody[1][1] = tmpSnakeY-Snake.SPRITE_SIZE;
		SnakeBody[2][0] = tmpSnakeX;
		SnakeBody[2][1] = tmpSnakeY;
		SnakeBody[3][0] = tmpSnakeX;
		SnakeBody[3][1] = tmpSnakeY+Snake.SPRITE_SIZE;
		SnakeBody[4][0] = tmpSnakeX;
		SnakeBody[4][1] = tmpSnakeY+Snake.SPRITE_SIZE*2;
	}
	
//  	
	public void Draw(Canvas canvas) {
		Move();
		for(int i=1;i<SnakeLength;i++) {
			if ((i>0)&&(i<SnakeLength-1)) {
				BodyImg.setBounds(SnakeBody[i][0], SnakeBody[i][1], SnakeBody[i][0]+frameWidth, SnakeBody[i][1]+frameHeight);
				BodyImg.draw(canvas);
			}
			if (i==SnakeLength-1) {
				if (SnakeBody[SnakeLength-2][0]<SnakeBody[SnakeLength-1][0]) {
					TailImg[1].setBounds(SnakeBody[i][0], SnakeBody[i][1], SnakeBody[i][0]+frameWidth, SnakeBody[i][1]+frameHeight);
					TailImg[1].draw(canvas);
				}
				if (SnakeBody[SnakeLength-2][0]>SnakeBody[SnakeLength-1][0]) {
					TailImg[0].setBounds(SnakeBody[i][0], SnakeBody[i][1], SnakeBody[i][0]+frameWidth, SnakeBody[i][1]+frameHeight);
					TailImg[0].draw(canvas);
				}
				if (SnakeBody[SnakeLength-2][1]<SnakeBody[SnakeLength-1][1]) {
					TailImg[2].setBounds(SnakeBody[i][0], SnakeBody[i][1], SnakeBody[i][0]+frameWidth, SnakeBody[i][1]+frameHeight);
					TailImg[2].draw(canvas);
				}
				if (SnakeBody[SnakeLength-2][1]>SnakeBody[SnakeLength-1][1]) {
					TailImg[3].setBounds(SnakeBody[i][0], SnakeBody[i][1], SnakeBody[i][0]+frameWidth, SnakeBody[i][1]+frameHeight);
					TailImg[3].draw(canvas);
				}
			}
		}
		HeadImg[Direction].setBounds(SnakeBody[0][0], SnakeBody[0][1], SnakeBody[0][0]+frameWidth, SnakeBody[0][1]+frameHeight);
		HeadImg[Direction].draw(canvas);
	}

//    	
	public void Increase() {
		SnakeLength++;
	}
	
//   
	public void Decrise() {
		if (SnakeLength>5) {
			SnakeLength--;
		}
	}

//        	
	public void SetDirectionBySensor(float axX, float axY, float axZ) {
		if (Math.abs(axX) > Math.abs(axY)) {
			if (axX < -2) Direction = 0;		// Right
			if (axX > 2) Direction = 1;			// Left
		}
		
		if (Math.abs(axY) > Math.abs(axX)) {
			if (axY < -2) Direction = 2;		// Up
			if (axY > 2) Direction = 3;			// Down
		}
	}
	
//  	
	private void Move() {
		switch (Direction) {	
			case 0:
				if (SnakeBody[0][0] + Speed + frameWidth <= screenWidth) { 
					for(int i=SnakeLength-1;i>0;i--) {
						SnakeBody[i][0] = SnakeBody[i-1][0];
						SnakeBody[i][1] = SnakeBody[i-1][1];
					}
					SnakeBody[0][0] = SnakeBody[0][0] + Speed;
				} else crash = true;
				break;
			case 1:
				if (SnakeBody[0][0] - Speed >= 0) { 
					for(int i=SnakeLength-1;i>0;i--) {
						SnakeBody[i][0] = SnakeBody[i-1][0];
						SnakeBody[i][1] = SnakeBody[i-1][1];
					}
					SnakeBody[0][0] = SnakeBody[0][0] - Speed;
				} else crash = true;
				break;
			case 2:
				if (SnakeBody[0][1] - Speed >= Snake.STATISTIC_LINE) {
					for(int i=SnakeLength-1;i>0;i--) {
						SnakeBody[i][0] = SnakeBody[i-1][0];
						SnakeBody[i][1] = SnakeBody[i-1][1];
					}
					SnakeBody[0][1] = SnakeBody[0][1] - Speed;
				} else crash = true;
				break;
			case 3:
				if (SnakeBody[0][1] + Speed + frameHeight <= screenHeight) {
					for(int i=SnakeLength-1;i>0;i--) {
						SnakeBody[i][0] = SnakeBody[i-1][0];
						SnakeBody[i][1] = SnakeBody[i-1][1];
					}
					SnakeBody[0][1] = SnakeBody[0][1] + Speed;
				} else crash = true;
				break;
		}
	}
	
//      
	public boolean checkSelfCrash() {
		for(int i=1;i<SnakeLength;i++) {
			if ((SnakeBody[0][0] == SnakeBody[i][1])&&(SnakeBody[0][1] == SnakeBody[i][1])) {
				return true;
			}
		}
		return false;
	}
	
//      
	public boolean checkCrash() {
		return crash;
	}
	
//    	
	public boolean checkRabbits(Rabbits rabbit) {
		if ((SnakeBody[0][0] == rabbit.getRabbitX())&&(SnakeBody[0][1] == rabbit.getRabbitY())) {
			return true;
		}
		return false;
	}
	
//    	
	public boolean checkCarrots(Carrots carrot) {
		if ((SnakeBody[0][0] == carrot.getCarrotX())&&(SnakeBody[0][1] == carrot.getCarrotY())) {
			return true;
		}
		return false;
	}	
	
//    
	public boolean checkCherrys(Cherry cherry ) {
		if ((SnakeBody[0][0] == cherry.getCherryX())&&(SnakeBody[0][1] == cherry.getCherryY())) {
			return true;
		}
		return false;
	}		
	
//    	
	public boolean checkLimons(Limon limon) {
		if ((SnakeBody[0][0] == limon.getLimonX())&&(SnakeBody[0][1] == limon.getLimonY())) {
			return true;
		}
		return false;
	}		
	
//    	
	public boolean checkMushrooms(Mushrooms mushroom) {
		if ((SnakeBody[0][0] == mushroom.getMushroomX())&&(SnakeBody[0][1] == mushroom.getMushroomY())) {
			return true;
		}
		return false;
	}		
	
//    	
	public boolean checkPears(Pear pear) {
		if ((SnakeBody[0][0] == pear.getPearX())&&(SnakeBody[0][1] == pear.getPearY())) {
			return true;
		}
		return false;
	}		
	
//    
	public boolean checkFrogs(Frogs frog) {
		if ((SnakeBody[0][0] == frog.getFrogX())&&(SnakeBody[0][1] == frog.getFrogY())) {
			return true;
		}
		return false;
	}		
	
//    	
	public boolean checkChickens(Chickens chicken) {
		if ((SnakeBody[0][0] == chicken.getChickenX())&&(SnakeBody[0][1] == chicken.getChickenY())) {
			return true;
		}
		return false;
	}		
	
//   
	public int getLength() {
		return SnakeLength;
	}
	
//   
	public void setLength(int newLength) {
		SnakeLength = newLength;
	}
	
//   
	public void resetLength() {
		SnakeLength = 5;
	}
	
//   
	public void lifesUp(int addLifes) {
		Lifes = Lifes + addLifes;
		if (Lifes>9) Lifes = 9;
	}
	
//  
	public boolean lifesDown() {
		Lifes--;
		if (Lifes<0) {
			Lifes = 0;
			return false;
		}
		return true;
	}
	
//   
	public int getLifes() {
		return Lifes;
	}
	
//   
	public void setLifes(int newLifes) {
		Lifes = newLifes;
	}
	
//  
	public int[][] getSnakeBody() {
		return SnakeBody;
	}
	
//  
	public void setSnakeBody(int[][] newSnakeBody) {
		for(int i=0;i<100;i++) {
			SnakeBody[i][0] = newSnakeBody[i][0];
			SnakeBody[i][1] = newSnakeBody[i][1];
		}
	}
}
